const fs = require('fs')
const path = require('path')

let packageJsonPath = process.cwd()

while (!fs.existsSync(path.join(packageJsonPath, 'package.json'))) {
    packageJsonPath = path.dirname(packageJsonPath)
    if (packageJsonPath === path.resolve('/')) {
        packageJsonPath = null
        break
    }
}

const packageJson = packageJsonPath === null ? null : require(path.join(packageJsonPath, 'package.json'))

const has = (...libs) =>
    libs.some((name) => {
        if (packageJsonPath === null) {
            return false
        }
        return !!packageJson.dependencies?.[name] || !!packageJson.devDependencies?.[name]
    })

module.exports = {
    react: has('react'),
    next: has('next'),
    typescript: has('typescript'),
    jest: has('jest'),
}
